"""workflow-run

Revision ID: 059ae42eb9b5
Revises: d923fdfe3bf2
Create Date: 2023-06-06 13:24:37.465030

"""
from alembic import op
import sqlalchemy as sa
import ryax.runner.infrastructure.database.metadata


# revision identifiers, used by Alembic.
revision = '059ae42eb9b5'
down_revision = 'd923fdfe3bf2'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('workflow_run',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('project_id', sa.String(), nullable=True),
    sa.Column('workflow_definition_id', sa.String(), nullable=True),
    sa.Column('state', sa.Enum('CANCELED', 'ERROR', 'RUNNING', 'COMPLETED', name='workflow_run_state'), nullable=True),
    sa.Column('number_of_action_results', sa.Integer(), nullable=True),
    sa.Column('number_of_actions', sa.Integer(), nullable=True),
    sa.Column('started_at', ryax.runner.infrastructure.database.metadata.TZDateTime(), nullable=True),
    sa.Column('last_result_at', ryax.runner.infrastructure.database.metadata.TZDateTime(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('action_run',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('state', sa.Enum('SUCCESS', 'ERROR', 'RUNNING', 'WAITING', 'CANCELED', name='action_run_state'), nullable=False),
    sa.Column('position', sa.Integer(), nullable=False),
    sa.Column('workflow_run_id', sa.String(), nullable=True),
    sa.Column('workflow_action_id', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['workflow_action_id'], ['workflow_action.id'], ),
    sa.ForeignKeyConstraint(['workflow_run_id'], ['workflow_run.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.add_column('action_definition', sa.Column('addons', sa.JSON(), nullable=True))
    op.drop_constraint('action_input_types_action_definition_id_fkey', 'action_input_types', type_='foreignkey')
    op.create_foreign_key(None, 'action_input_types', 'action_definition', ['action_definition_id'], ['id'])
    op.drop_constraint('action_output_types_action_definition_id_fkey', 'action_output_types', type_='foreignkey')
    op.create_foreign_key(None, 'action_output_types', 'action_definition', ['action_definition_id'], ['id'])
    op.drop_constraint('execution_connection_parent_execution_result_id_fkey', 'execution_connection', type_='foreignkey')
    op.create_foreign_key(None, 'execution_connection', 'execution_result', ['parent_execution_result_id'], ['id'])
    op.add_column('execution_result', sa.Column('action_run_id', sa.String(), nullable=True))
    op.create_foreign_key(None, 'execution_result', 'action_run', ['action_run_id'], ['id'])
    op.drop_constraint('stored_file_association_execution_result_id_fkey', 'stored_file_association', type_='foreignkey')
    op.drop_constraint('stored_file_association_stored_file_id_fkey', 'stored_file_association', type_='foreignkey')
    op.create_foreign_key(None, 'stored_file_association', 'execution_result', ['execution_result_id'], ['id'])
    op.create_foreign_key(None, 'stored_file_association', 'stored_file', ['stored_file_id'], ['id'])
    op.drop_constraint('workflow_action_association_parents_fkey', 'workflow_action_association', type_='foreignkey')
    op.drop_constraint('workflow_action_association_children_fkey', 'workflow_action_association', type_='foreignkey')
    op.create_foreign_key(None, 'workflow_action_association', 'workflow_action', ['children'], ['id'])
    op.create_foreign_key(None, 'workflow_action_association', 'workflow_action', ['parents'], ['id'])
    op.drop_constraint('workflow_action_dynamic_outputs_workflow_action_id_fkey', 'workflow_action_dynamic_outputs', type_='foreignkey')
    op.create_foreign_key(None, 'workflow_action_dynamic_outputs', 'workflow_action', ['workflow_action_id'], ['id'])
    op.drop_constraint('workflow_action_static_inputs_workflow_action_id_fkey', 'workflow_action_static_inputs', type_='foreignkey')
    op.create_foreign_key(None, 'workflow_action_static_inputs', 'workflow_action', ['workflow_action_id'], ['id'])
    op.drop_constraint('workflow_result_workflow_deployment_id_fkey', 'workflow_result', type_='foreignkey')
    op.create_foreign_key(None, 'workflow_result', 'workflow_deployment', ['workflow_deployment_id'], ['id'])
    # ### end Alembic commands ###

    with op.get_context().autocommit_block():
        op.execute("ALTER TYPE execution_result_state ADD VALUE 'CREATED'")


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(None, 'workflow_result', type_='foreignkey')
    op.create_foreign_key('workflow_result_workflow_deployment_id_fkey', 'workflow_result', 'workflow_deployment', ['workflow_deployment_id'], ['id'], ondelete='CASCADE')
    op.drop_constraint(None, 'workflow_action_static_inputs', type_='foreignkey')
    op.create_foreign_key('workflow_action_static_inputs_workflow_action_id_fkey', 'workflow_action_static_inputs', 'workflow_action', ['workflow_action_id'], ['id'], ondelete='CASCADE')
    op.drop_constraint(None, 'workflow_action_dynamic_outputs', type_='foreignkey')
    op.create_foreign_key('workflow_action_dynamic_outputs_workflow_action_id_fkey', 'workflow_action_dynamic_outputs', 'workflow_action', ['workflow_action_id'], ['id'], ondelete='CASCADE')
    op.drop_constraint(None, 'workflow_action_association', type_='foreignkey')
    op.drop_constraint(None, 'workflow_action_association', type_='foreignkey')
    op.create_foreign_key('workflow_action_association_children_fkey', 'workflow_action_association', 'workflow_action', ['children'], ['id'], ondelete='CASCADE')
    op.create_foreign_key('workflow_action_association_parents_fkey', 'workflow_action_association', 'workflow_action', ['parents'], ['id'], ondelete='CASCADE')
    op.drop_constraint(None, 'stored_file_association', type_='foreignkey')
    op.drop_constraint(None, 'stored_file_association', type_='foreignkey')
    op.create_foreign_key('stored_file_association_stored_file_id_fkey', 'stored_file_association', 'stored_file', ['stored_file_id'], ['id'], ondelete='CASCADE')
    op.create_foreign_key('stored_file_association_execution_result_id_fkey', 'stored_file_association', 'execution_result', ['execution_result_id'], ['id'], ondelete='CASCADE')
    op.drop_constraint(None, 'execution_result', type_='foreignkey')
    op.drop_column('execution_result', 'action_run_id')
    op.drop_constraint(None, 'execution_connection', type_='foreignkey')
    op.create_foreign_key('execution_connection_parent_execution_result_id_fkey', 'execution_connection', 'execution_result', ['parent_execution_result_id'], ['id'], ondelete='CASCADE')
    op.drop_constraint(None, 'action_output_types', type_='foreignkey')
    op.create_foreign_key('action_output_types_action_definition_id_fkey', 'action_output_types', 'action_definition', ['action_definition_id'], ['id'], ondelete='CASCADE')
    op.drop_constraint(None, 'action_input_types', type_='foreignkey')
    op.create_foreign_key('action_input_types_action_definition_id_fkey', 'action_input_types', 'action_definition', ['action_definition_id'], ['id'], ondelete='CASCADE')
    op.drop_column('action_definition', 'addons')
    op.drop_table('action_run')
    op.drop_table('workflow_run')
    # ### end Alembic commands ###
